local B=LibStub("AceAddon-3.0"):GetAddon("DKP Bidder");



function B:GUILD_ROSTER_UPDATE(arg,arg2)
	if (B.view.rosterFrame==nil) then
		self:ReadGuildRosterData()
	else
		if ((B.view.rosterFrame:IsVisible()) or B.mainFrame:IsVisible()) and GetNumGuildMembers()>0 then
			self:ReadGuildRosterData()
			B.view.rosterFrame:UpdateList();
			B.view.dkpAmountString:SetText("DKP: "..self.players[UnitName("player")].net);
		end;
	end;

end;
function B:ClearTransferQueue()
	if #B.transfer>0 then
		self:Print("Clearing transfer queue. No DKP manager was found. There must be at least one player with working manager module in order to perform transfer.");
		wipe(self.transfer);
	end
end
function B:Transfer(amount,players)
	amount=math.floor(amount/#players);

	for i=1,#players do
		table.insert(B.transfer,{name=players[i],amount=amount});
		self:Print("Adding transfer into queue: "..amount.." DKP to "..B.colors.class[B.players[players[i]].class][5]..players[i]);
	end
	self:Print("Looking for DKP manager.");
	self:Send("LFDKPManager",nil,"GUILD");
	self:ScheduleTimer(self.ClearTransferQueue, 3,self);
end

function B:Send(msg,data,dist,target)
	local sendData={msg=msg,data=data};
	local msg=self:Serialize(sendData);
	SendAddonMessage(B.prefix,msg,dist,target);
end;

function B:Bid(amount)
	if amount>=self.minBid then
		self:Send("playerBid",amount, "WHISPER", self.bidMaster);
	else
		self:Print("You have to bid more then minimum bid: "..self.minBid);
	end
end




function B:OnCommReceived(prefix, message, distribution, sender)
	suc,data=self:Deserialize(message);
	if suc then
		local msg=data.msg;
		local data=data.data
		if (prefix==B.prefix) then
			if (msg=="IAMDKPManager") then
				if #B.transfer>0 then
					B:Print("DKP master found: "..sender..". Sending transfer request.");
					for i=1,#B.transfer do
						self:Send("transferDKP",{transferTo=B.transfer[1].name,amount=B.transfer[1].amount},"WHISPER",sender);
						table.remove(B.transfer,1);
					end
				end
			elseif (msg=="startTimer") then
				if (sender==B.bidMaster) then
					B:CreateTimerFrame(tonumber(message));
				end
			elseif (msg=="broadcastBid") then
				if (sender==B.bidMaster) then
					if self:GetBidderList():GetDataByKey(data.bidderName)~=nil then
						self:GetBidderList():GetDataByKey(data.bidderName)[3].name=tonumber(data.amount);
						self:GetBidderList():GetDataByKey(data.bidderName)[3].timeOfBid=data.timeOfBid
					else
						local listItem={
							self.countingFunction,
							{name=data.bidderName,color=B.colors.class[B.players[data.bidderName].class]},
							{name=tonumber(data.amount),timeOfBid=data.timeOfBid},
							{func=function(a,b,d) return d.net end, data=self.players[data.bidderName]},
						}

						self:GetBidderList():AddData(listItem,data.bidderName);
					end
					self:GetBidderList():Sort(3,function(a1,b1) return a1.timeOfBid<b1.timeOfBid end);
					self:GetBidderList():Sort(3,function(a1,b1) return a1.name>b1.name end);
					self:GetBidderList():UpdateView();
				end
			elseif msg=="startBids" then
				B.view.bidMasterString:SetText("Bid Master: "..sender);
				B.bidMaster=sender;
				self:GetBidderList():RemoveAll();
				B.view.minBidString:SetText("Min bid: "..data.minBid);
				B.view.bidEditBox:SetNumber(tonumber(data.minBid));
				B.minBid=tonumber(data.minBid);

				self:ChangeTitle(data.item,true)
				B.view.overBidButton:Enable();
				B.view.bidButton:Enable();
				PlaySound("RaidWarning", "Master");
				B.mainFrame:Show()
			elseif msg=="stopBids" then
				if sender==B.bidMaster then
					B.bidMaster=nil;
					B.view.bidMasterString:SetText("Bid Master: none");
					B.view.overBidButton:Disable();
					B.view.bidButton:Disable();
				end
			elseif msg=="askForVersion" then

				B:Send("returnVersion",self.ver,"WHISPER",sender);
			elseif msg=="error" then
				self:Print(B.colors["red"].."Error message"..B.colors["close"]..": '"..data..B.colors["close"].."'");
			elseif msg=="info" then
				self:Print(B.colors["blue"].."Info"..B.colors["close"]..": "..data..B.colors["close"].."");
			end
		end
	end
end;
