local gs=LibStub("GuiSkin-1.0");
local B=LibStub("AceAddon-3.0"):GetAddon("DKP Bidder");

function B:CreateGUI()
	Bidder.mainFrame=CreateFrame("Frame","DkpBidderGUIframe",UIParent);

	local f=Bidder.mainFrame;
	f:SetWidth(265);
	f:SetHeight(375);
	f:Hide();
	f:EnableMouse(true);
	f:SetMovable(true);
	f:SetPoint('TOPRIGHT',UIParent,'TOPRIGHT',-100 ,0)
	f:SetScript("OnMouseDown",
			function(self)
				self:StartMoving();
			end)
	f:SetScript("OnMouseUp",
			function(self)
				self:StopMovingOrSizing();
			end)
	f:SetScript("OnShow",
			function(self)
				PlaySound("igCharacterInfoOpen");
				if GetNumGuildMembers()>0 then
					B:ReadGuildRosterData()
					B.view.dkpAmountString:SetText("DKP: "..B.players[UnitName("player")].net);

				end;
				GuildRoster();
			end)
	f:SetScript("OnHide",
			function(self)
				PlaySound("igCharacterInfoClose");
			end)


	f:SetFrameStrata("MEDIUM");
	f:SetToplevel(true);
	local v=self.view;
	local dividerWidth=(B.mainFrame:GetWidth()-8)*256/(256-52);

	--BORDER textures part
	v["logoTexture"]=gs.CreateTexture(B.mainFrame,self.ver.."_logoTexture","BACKGROUND",58,58,"TOPLEFT", B.mainFrame, "TOPLEFT", 0,-8,[[Interface\Addons\DKP-Bidder\Arts\Logo2.tga]]);
	v["topRightTexture"]=gs.CreateTexture(B.mainFrame,self.ver.."_topRightTexture","BORDER",128,256,"TOPRIGHT", B.mainFrame, "TOPRIGHT", 35,0,[[Interface\TaxiFrame\UI-TaxiFrame-TopRight]]);
	v["topLeftTexture"]=gs.CreateTexture(B.mainFrame,self.ver.."_topLeftTexture","BORDER",256,256,"TOPLEFT", B.mainFrame, "TOPLEFT", -8,0,[[Interface\TaxiFrame\UI-TaxiFrame-TopLeft]]);
	v["botLeftTexture"]=gs.CreateTexture(B.mainFrame,self.ver.."_botLeftTexture","BORDER",256,286,"BOTTOMLEFT", B.mainFrame, "BOTTOMLEFT", -8,-76,[[Interface\TaxiFrame\UI-TaxiFrame-BotLeft]]);
	v["botRightTexture"]=gs.CreateTexture(B.mainFrame,self.ver.."_botRightTexture","BORDER",128,286,"BOTTOMRIGHT", B.mainFrame, "BOTTOMRIGHT", 35,-76,[[Interface\TaxiFrame\UI-TaxiFrame-BotRight]]);


	--close button
	self.view["closeButton"]= CreateFrame("Button",self.ver.."closeButton", self.mainFrame, "UIPanelCloseButton");
	local cb=self.view["closeButton"];
	cb:SetPoint("TOPRIGHT",self.mainFrame,"TOPRIGHT",5,-8);
	cb:SetWidth(32);
	cb:SetHeight(32);
	--//


	--top gui part
	v.dkpAmountString=gs.CreateFontString(B.mainFrame,self.ver.."_dkpAmountString","ARTWORK","DKP:","TOPLEFT",B.mainFrame,"TOPLEFT",70,-45);
	local t=v.dkpAmountString
	t:SetFont([[Fonts\MORPHEUS.ttf]],18);
	--t:SetTextColor(1,1,1,1);
	--//

	--info part
	v.basicInfoTitleString=gs.CreateFontString(B.mainFrame,self.ver.."_basicInfoTitleString","ARTWORK","Info","TOP",B.mainFrame,"TOP",0,-80);
	v.minBidString=gs.CreateFontString(B.mainFrame,self.ver.."_minBidString","ARTWORK","Min bid: unknown","TOPLEFT",B.mainFrame,"TOPLEFT",20,-95);
	v.bidMasterString=gs.CreateFontString(B.mainFrame,self.ver.."_BidMasterString","ARTWORK","Bid master: unknown","TOPLEFT",v.minBidString,"BOTTOMLEFT",0,-5);
	v.listDivider=gs.CreateTexture(B.mainFrame,self.ver.."_dividerBorder","ARTWORK",dividerWidth,16,"TOPLEFT", B.mainFrame, "TOPLEFT", 6,-128,[[Interface\MailFrame\MailPopup-Divider]]);
	--//

	--bidding list part
	v.listTitleString=gs.CreateFontString(B.mainFrame,self.ver.."_listTitleString","ARTWORK","Bidding list","TOP",B.mainFrame,"TOP",0,-135);
	local data={columns={"Nr","Name","Bid","Total"},columnsWidth={25,128,40,40},rows=5,height=88};
	self.countingFunction=function(a) return a.."." end;
	v.bidderList=LibStub("WowList-1.0"):CreateNew(self.ver.."_bidderList",data,B.mainFrame);
	v.bidderList:SetPoint('TOPLEFT', B.mainFrame,'TOPLEFT', 16,-150);
	v.bidderList:SetMultiSelection(false);
	--//



	--buttons part
	--button divider
	v.buttonDivider=gs.CreateTexture(B.mainFrame,nil,"ARTWORK",dividerWidth,16,"TOPLEFT", v.listDivider, "TOPLEFT", 0,-110,[[Interface\MailFrame\MailPopup-Divider]]);

	--bidEditBox
	v.bidEditBox = CreateFrame("EditBox", self.ver.."Amount", B.mainFrame, "InputBoxTemplate")
	v.bidEditBox:SetMaxLetters(5)
	v.bidEditBox:SetNumeric()
	v.bidEditBox:SetNumber(0);
	v.bidEditBox:SetPoint('TOPLEFT', v.bidderList,'BOTTOMLEFT', 7,-20)
	v.bidEditBox:SetAutoFocus(false);
	v.bidEditBox:SetScript("OnEscapePressed",function(self)
		self:ClearFocus();
	  end)
	--//bidEditBox


	--Bid Button
	v.bidButton = CreateFrame("Button", self.ver.."ButtonBid", B.mainFrame, "UIPanelButtonTemplate")
	v.bidButton:SetText("Bid");
	v.bidButton:SetPoint('TOPLEFT', v.bidEditBox,'TOPRIGHT', 5,0)
	v.bidButton:SetScript("OnClick",function(self)
		B:Bid(v.bidEditBox:GetNumber());
	  end)
	--//Bid Button


	---EditBox for over bidding
	v.overBidEditBox = CreateFrame("EditBox", self.ver.."OverAmount", B.mainFrame, "InputBoxTemplate")
	v.overBidEditBox:SetMaxLetters(6)
	v.overBidEditBox:SetNumeric()
	v.overBidEditBox:SetPoint('TOPLEFT', v.bidEditBox,'BOTTOMLEFT',0 ,-5)
	v.overBidEditBox:SetNumber(10);
	v.overBidEditBox:Show();
	v.overBidEditBox:SetAutoFocus(false);
	v.overBidEditBox:SetScript("OnEscapePressed",function(self)
		self:ClearFocus();
	  end)
	v.overBidEditBox:SetScript("OnTextChanged",function()
		v.overBidButton:SetText("OverBid by "..v.overBidEditBox:GetNumber());
	  end)
	--//EditBox

	--OverBid Button
	v.overBidButton = CreateFrame("Button", self.ver.."ButtonOverBid", B.mainFrame, "UIPanelButtonTemplate")

	v.overBidButton:SetText("OverBid by "..v.overBidEditBox:GetNumber());
	v.overBidButton:SetPoint('TOPLEFT',v.overBidEditBox,'TOPRIGHT', 5,0)
	v.overBidButton:SetScript("OnClick",function()
		if B:GetBidderList():GetData(1)~=nil then
			B:Bid(v.overBidEditBox:GetNumber()+B:GetBidderList():GetData(1)[3].name);
		else
			B:Bid(B.minBid);
		end
	  end)
	--//OverBid Button

	--Roster button
	v.openRosterButton= CreateFrame("Button", nil, B.mainFrame, "UIPanelButtonTemplate")
	v.openRosterButton:SetText("Open DKP roster");
	v.openRosterButton:SetPoint('TOPLEFT', v.overBidButton,'BOTTOMLEFT', 0,-5)
	v.openRosterButton:SetScript("OnClick",function(self)
		B.view.rosterFrame:Show();
	  end)
	--//Roster Button




	self:CreateTitle()
	self:CreateTimerFrame();
	v.timerFrame:SetPoint("BOTTOMLEFT",B.mainFrame,"BOTTOMLEFT",14,20);
	v.timerFrame:SetWidth(B.mainFrame:GetWidth()-24);
	v.timerFrame:SetHeight(16);
	--self:CreateTimerFrame(30);
	v.rosterFrame=B:CreateRosterFrame();

	--disable buttons
	v.overBidButton:Disable();
	v.bidButton:Disable();

end



--SET TITLE - window with linked item or other useless info.
function Bidder:CreateTitle()
	local v=B.view;
	v.titleFrame = CreateFrame("Frame",self.ver.."_TitleFrame",B.mainFrame)
	v.titleString=gs.CreateFontString(B.mainFrame,self.ver.."_Title","ARTWORK","DKP Bidder","TOP",v.titleFrame,"TOP",18,-14);
	local title=self.view["title"];
	v.titleFrame:SetHeight(20)
	v.titleFrame:SetWidth(v.titleString:GetWidth() + 20)
	v.titleString:SetPoint("TOP", B.mainFrame, "TOP", 18,-18);
	v.titleFrame:SetPoint("TOP", v.titleString, "TOP", 0, 0);
	v.titleFrame:SetMovable(true)
	v.titleFrame:EnableMouse(true)
	v.titleFrame:SetScript("OnMouseDown",function()
		B.mainFrame:StartMoving()
	end)
		v.titleFrame:SetScript("OnMouseUp",function()
		B.mainFrame:StopMovingOrSizing()
	end)

	v.titleFrameHelp = CreateFrame("Frame",nil,B.mainFrame)
	v.titleFrame:SetScript("OnEnter", function(self)
		v.titleFrameHelp:SetScript("OnUpdate", 	function()
				B:ShowGameTooltip();
			end)
	end)
	v.titleFrame:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
		v.titleFrameHelp:SetScript("OnUpdate", 	function()
				-- Dont do anything
			end)
	end)
end
function B:ShowGameTooltip()
	local v=self.view;
	GameTooltip_SetDefaultAnchor( GameTooltip, UIParent )
	GameTooltip:ClearAllPoints();
	GameTooltip:SetPoint("bottom", v.titleFrame, "top", 0, 0)
	GameTooltip:ClearLines()

	if self.tolltipHasItem then
		GameTooltip:SetHyperlink(v.titleString:GetText())
	end
end


B.timeLeft=0;

function B:CreateTimerFrame(timeleft)--TODO: move this to gui lib
	if timeleft==nil then timeleft=-1 end;
	local v=B.view;
	B.timerIsOn=true;
	if v.StringTimer~=nil then v.StringTimer:SetText("Time left for bidding: "..timeleft); end;
	B.timeLeft=timeleft;
	if(v.timerFrame == nil) then
		v.timerFrame = CreateFrame("Frame",self.ver.."_timerFrameBackground", B.mainFrame);

		v.timerProgressFrame = CreateFrame("Frame",self.ver.."_timerFrame", v.timerFrame);


		v.timerProgressFrame:SetScript("onUpdate",function (self,elapse)
						if B.timeLeft>0 and B.timerIsOn then
							local a=B.timeLeft;
							v.timerProgressFrame:SetHeight(self:GetParent():GetHeight())
							if B.timeLeft<=15 then
								v.timerProgressFrame:SetBackdropColor(0.5-B.timeLeft/30,B.timeLeft/30,0,1)
								v.timerProgressFrame:SetWidth((self:GetParent():GetWidth())*B.timeLeft/15)
							else
								v.timerProgressFrame:SetBackdropColor(0,0.5,0,1)
								v.timerProgressFrame:SetWidth(self:GetParent():GetWidth())
							end;
							B.timeLeft=B.timeLeft-elapse;
							if ceil(B.timeLeft)<ceil(a) then
								if ceil(a)~=0 then v.StringTimer:SetText("Time left: "..ceil(B.timeLeft)); end;
							end;
						elseif B.timerIsOn then

							B.timerIsOn=false;

							v.StringTimer:SetText("Timer off.");

						end;
					end);
		local backdrop = {
			bgFile =  gs.blank,  -- path to the background texture
			edgeFile = "",  -- path to the border texture
			tile = false,    -- true to repeat the background texture to fill the frame, false to scale it
			tileSize = 0,  -- size (width or height) of the square repeating background tiles (in pixels)
			edgeSize = 0,  -- thickness of edge segments and square size of edge corners (in pixels)
			insets = {    -- distance from the edges of the frame to those of the background texture (in pixels)
				left = 0,
				right =0,
				top = 0,
				bottom = 0
			}
		}
		v.timerProgressFrame:SetBackdrop(backdrop);


		v.timerProgressFrame:SetHeight(v.timerFrame:GetHeight()-2);
		v.timerProgressFrame:SetWidth(0);

		v.StringTimer  = v.timerProgressFrame:CreateFontString(self.ver.."StringTimer","OVERLAY","GameFontNormal")
		v.StringTimer:SetText("Timer off.");
		v.timerProgressFrame:Show();
		v.timerProgressFrame:SetPoint("TOPLEFT",v.timerFrame,"TOPLEFT",0,0);
		v.StringTimer:SetPoint("TOP",v.timerFrame,"TOP",0,-3);
		B.timerIsOn=false;
	end




	--for not reapeatable call on settext;


end



--  Minimap Button  --
--[[
function B:ShowMinimapButton()
	v.MinimapIcon:Show()
	DkpBidder["settings"].icon = true
end
function B:HideMinimapButton()
	v.MinimapIcon:Hide()
	DkpBidder["settings"].icon = false
end

function B:CheckMinimapStatus()
	if DkpBidder["settings"].icon == false then

		v.MinimapIcon:Hide()
	end
end]]


--[[
do
	local button = CreateFrame("Button", self.ver.."MinimapIcon", Minimap)
	button:SetHeight(32)
	button:SetWidth(32)
	button:SetFrameStrata("MEDIUM")
	button:SetPoint("CENTER", DkpBidder["settings"].icon_xpos, DkpBidder["settings"].icon_ypos)
	button:SetMovable(true)
	button:SetUserPlaced(true)
	button:SetNormalTexture("Interface\\AddOns\\DkpBidder\\Images\\button_up")
	button:SetPushedTexture("Interface\\AddOns\\DkpBidder\\Images\\button_down")
	button:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")

	button:SetScript("OnEnter", function(self)
		GameTooltip_SetDefaultAnchor(GameTooltip,  UIParent )
		GameTooltip:SetPoint("bottom", v.MinimapIcon, "top", 0, 0)
		local cs = "|cffffffcc"
		local ce = "|r"
		GameTooltip:ClearLines()
		GameTooltip:AddLine("QDKP Bidder " .. v.version)
		GameTooltip:AddLine(string.format("%sLeft-Click%s to toggle the bidder.", cs, ce))
		GameTooltip:AddLine(string.format("%sRight-Click%s to move this button", cs, ce))
		GameTooltip:AddLine(string.format("%sShift+Click%s to hide this button", cs, ce))
		GameTooltip:Show()
	end)

	button:SetScript("OnLeave", function(self)
		GameTooltip:Hide()
	end)

	local dragMode = nil

	local function moveButton(self)
		local centerX, centerY = Minimap:GetCenter()
		local x, y = GetCursorPosition()
		x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
		centerX, centerY = math.abs(x), math.abs(y)
		centerX, centerY = (centerX / math.sqrt(centerX^2 + centerY^2)) * 80, (centerY / sqrt(centerX^2 + centerY^2)) * 80
		DkpBidder["settings"].icon_xpos = x < 0 and -centerX or centerX
		DkpBidder["settings"].icon_ypos = y < 0 and -centerY or centerY
		self:ClearAllPoints()
		self:SetPoint("CENTER", DkpBidder["settings"].icon_xpos, DkpBidder["settings"].icon_ypos)
	end

	button:SetScript("OnMouseUp", function(self)
		self:SetScript("OnUpdate", nil)
	end)

	button:SetScript("OnMouseDown", function(self, button)
		if IsShiftKeyDown() then
			v.HideMinimapButton();
		elseif button == "RightButton" then
			dragMode = nil
			self:SetScript("OnUpdate", moveButton)
		elseif button == "LeftButton" then
			v.ToggleBidder()
		end
	end)

end]]
function B:ToggleBidder()
	if (B.mainFrame:IsShown()==nil) then

		self.mainFrame:Show();
	else self.mainFrame:Hide()
	end
end

function B:CreateRosterFrame()

		local f=gs:CreateFrame(self.ver.."_RosterFrame","DKP Roster","BASIC",400,375,'LEFT',UIParent,'LEFT',100 ,0);
		f:Hide();
		f.showAlts=true;
		f.showOffline=true;
		f.view={};
		f:SetScript("OnShow",
				function(self)
					PlaySound("igCharacterInfoOpen");
					self:UpdateList();
					GuildRoster();
				end)
		f:SetScript("OnHide",
				function(self)
					PlaySound("igCharacterInfoClose");
				end)
		local v=f.view;
		v.dropDownMenu= CreateFrame("Frame", B.ver.."DKPBidder_TitleDropDownMenu", f, "UIDropDownMenuTemplate")

		function f:RightMouseClick(arg,arg2)
			local cursorX, cursorY = GetCursorPosition()
			local scale=UIParent:GetEffectiveScale();
			EasyMenu(B.dropDownMenuTable, self.view.dropDownMenu,"UIParent", cursorX/scale, cursorY/scale, "MENU",0.5)

		end
		local data={columns={"Name","Current","Overall","Spent","Rank"},columnsWidth={90,60,60,60,90},rows=20,height=290};

		v.bidderList=LibStub("WowList-1.0"):CreateNew(self:GetName().."_bidderList",data,f);
		v.bidderList:SetPoint('TOPLEFT', f,'TOPLEFT', 16,-30);
		v.bidderList:SetColumnSortFunction(1,function(a,b) return a.data.name<b.data.name end)
		v.bidderList:SetColumnSortFunction(2,function(a,b) return a>b end)
		v.bidderList:SetColumnSortFunction(3,function(a,b) return a>b end)
		v.bidderList:SetColumnSortFunction(4,function(a,b) return a>b end)
		v.bidderList:SetColumnSortFunction(5,function(a,b) return a.rankIndex>b.rankIndex end)
		v.bidderList.RegisterCallback(f, "RightMouseClick");

		v.altsCheckBox=gs.CreateCheckBox(f,"Show alts");
		v.altsCheckBox:Show();
		v.altsCheckBox:SetPoint('BOTTOMLEFT', f,'BOTTOMLEFT', 16,10);
		v.altsCheckBox:SetChecked(true);
		v.altsCheckBox:SetScript("OnClick",function(self, button, down)
			if self:GetChecked() then
				self:GetParent().view.bidderList:RemoveFilter("showAlts");
				self:GetParent().view.bidderList:UpdateView();
			else
				self:GetParent().view.bidderList:AddFilter("showAlts",function(data) return data[1].data.main==data[1].data.name end);
				self:GetParent().view.bidderList:UpdateView();
			end
		end)

		v.offlineCheckBox=gs.CreateCheckBox(f,"Show offline");
		v.offlineCheckBox:Show();
		v.offlineCheckBox:SetPoint('BOTTOMLEFT',v.altsCheckBox,'BOTTOMRIGHT', 100,0);
		v.offlineCheckBox:SetChecked(true);
		v.offlineCheckBox:SetScript("OnClick",function(self, button, down)
			if self:GetChecked() then
				self:GetParent().view.bidderList:RemoveFilter("showOffline");
				self:GetParent().view.bidderList:UpdateView();
			else
				self:GetParent().view.bidderList:AddFilter("showOffline",function(data) return data[1].data.online end);
				self:GetParent().view.bidderList:UpdateView();
			end
		end)

		v.showRaidMembersCheckBox=gs.CreateCheckBox(f,"Raid only");
		v.showRaidMembersCheckBox:Show();
		v.showRaidMembersCheckBox:SetPoint('BOTTOMLEFT',v.offlineCheckBox,'BOTTOMRIGHT', 100,0);
		v.showRaidMembersCheckBox:SetChecked(false);
		v.showRaidMembersCheckBox:SetScript("OnClick",function(self, button, down)
			if not self:GetChecked() then
				self:GetParent().view.bidderList:RemoveFilter("showRaidMembersOnly");
				self:GetParent().view.bidderList:UpdateView();
			else
				self:GetParent().view.bidderList:AddFilter("showRaidMembersOnly",function(data)
					for i=1,GetNumRaidMembers() do
						if GetRaidRosterInfo(i)==data[1].data.name then return true end;
					end;
					return false
				end);
				self:GetParent().view.bidderList:UpdateView();
			end
		end)
		function f:UpdateList()
			local players=B.players;
			local v=self.view;
			local data;

			for i,d in pairs(v.bidderList:GetKeySet()) do

				if B.players[i]==nil then

					v.bidderList:RemoveData(d,i);

				end;
			end;

			for i,d in pairs(players) do

				if v.bidderList:GetDataByKey(i)==nil then
					data={
						{
							func=function(a,b,data) if data.main==data.name then return data.main else return data.name.."("..data.main..")" end end,
							data={main=d.main,name=i,online=d.online},
							color=d.color;
						},
						d.net,d.tot,(d.tot-d.net),{name=d.rank,rankIndex=d.rankIndex},
					}
					v.bidderList:AddData(data,i);

				else

					data=v.bidderList:GetDataByKey(i);
					data[1]={
							func=function(a,b,data) if data.main==data.name then return data.main else return data.name.."("..data.main..")" end end,
							data={main=d.main,name=i,online=d.online},
							color=d.color,
						};
					data[2]=d.net
					data[3]=d.tot
					data[4]=(d.tot-d.net)
					data[5]={name=d.rank,rankIndex=d.rankIndex}

				end;

			end;
			v.bidderList:UpdateView();
		end;
		return f;
end;
